<?php

require(DOCROOT.'/modules/mail/vendor/PHPMailer/PHPMailerAutoload.php');

function gradeSendMail($subject, $body, $sendToEmail, $sendToName) {
    $mail = new PHPMailer;

    //$mail->SMTPDebug = 3;                               // Enable verbose debug output

    $mail->isSMTP();                                      // Set mailer to use SMTP
    $mail->Host = 'class.mmcs.sfedu.ru';  // Specify main and backup SMTP servers
    $mail->SMTPAuth = false;                               // Enable SMTP authentication
    $mail->Username = NULL;                 // SMTP username
    $mail->Password = NULL;                           // SMTP password
    $mail->SMTPSecure = NULL;                            // Enable TLS encryption, `ssl` also accepted
    $mail->Port = 25;                                    // TCP port to connect to

    $mail->From = 'no_reply@grade.sfedu.ru';
    $mail->FromName = 'Grade System (Сервис БРС)';
    $mail->addAddress($sendToEmail, $sendToName);     // Add a recipient
    //$mail->addAddress('ellen@example.com');               // Name is optional
    //$mail->addReplyTo('info@example.com', 'Information');
    //$mail->addCC('cc@example.com');
    //$mail->addBCC('bcc@example.com');

    //$mail->addAttachment('/var/tmp/file.tar.gz');         // Add attachments
    //$mail->addAttachment('/tmp/image.jpg', 'new.jpg');    // Optional name
    //$mail->isHTML(true);                                  // Set email format to HTML

    $mail->Subject = $subject;
    $mail->Body    = $body;
    //$mail->ContentType = 'text/plain';
    $mail->CharSet = 'utf-8';
    //$mail->AltBody = 'This is the body in plain text for non-HTML mail clients';

    if(!$mail->send()) {
        Log::instance()->add(Log::NOTICE, 'Message could not be sent: '.$mail->ErrorInfo);
        //echo 'Mailer Error: ' . $mail->ErrorInfo;
    } else {
        Log::instance()->add(Log::NOTICE, 'Message has been sent');
    }
}

class Account
{
    private static function checkTokenLifetime($creationDate) {
        $config = Kohana::$config->load('security.securityPolicy');
        $lifetime = $config['recoveryToken']['lifetime'];
        return (time() - $creationDate) > $lifetime;
    }

    public static function checkToken($token) {
        $recovery = Model_Account::getRecoveryInfoByToken($token)[0];
        $response = true;

        if ($recovery['isUsed']) {
            $response = false;
        } else {
            $date = strtotime($recovery['Date']);
            if (self::checkTokenLifetime($date)) {
                Model_Account::useRecoveryToken($recovery['Token']);
                $response = false;
            }
        }
        return $response;
    }

    public static function createRecoveryRequest($email) {
        $requestToken = sha1($email.time().Cookie::$salt);

        $UserFullName = Model_Account::createRecoveryToken($email, $requestToken);
        if (!$UserFullName) {
            throw HTTP_Exception::factory(403, 'Пользователь с таким e-mail адресом не зарегистрирован в системе!');
        }

        $subject = ASSEMBLY_SYSTEM_NAME . ": Восстановление пароля";

        $twig = Twig::factory('email/recovery');
        $twig->curl = 'https://grade.sfedu.ru/'; // URL::base('https', TRUE); TODO: fix after mmcs.sfedu.ru gets SSL-certificate
        $twig->Token = $requestToken;
        $twig->EMail = $email;
        $twig->Subject = $subject;

        /* Kohana mailer is not working
        $status = Mailer::factory()
            ->headers('Content-Type', 'text/html; charset=utf-8')
            ->subject($subject)
            ->in_reply_to(Mailer::message_id())
            ->from('no-reply@rating.mmcs.sfedu.ru')
            ->body($twig->render())
            ->send($email);*/
        gradeSendMail($subject, $twig->render(), $email, $UserFullName);
    }

    // remind password
    public static function changePasswordByToken($token, $password) {
        $recovery = Model_Account::getRecoveryInfoByToken($token)[0];
        Model_Account::changePassword($recovery['AccountID'], $password);
        Model_Account::useRecoveryToken($token);
    }

    public static function doesLoginExist($login) {
        return Model_Account::checkAccountExistenceBy('login', $login);
    }

    public static function doesEmailExist($email) {
        return Model_Account::checkAccountExistenceBy('email', $email);
    }


//    // We don't change email address:\
//    public static function changeEMail($id, $newEMail) {
//        return (bool) Model_Account::changeMail($id, $newEMail);
//    }
}
