<?php defined('SYSPATH') or die('No direct script access.');

class HTTP_API_Exception extends HTTP_Exception
{
    /**
     * Creates an HTTP_Exception of the specified type.
     *
     * @param   integer $code the http status code
     * @param   string $message status message, custom content to display with error
     * @param   array $variables translation variables
     * @return  HTTP_Exception
     */
    public static function factory($code, $message = NULL, array $variables = NULL, Exception $previous = NULL) {
        $class = 'HTTP_API_Exception_' . $code;
        return new $class($message, $variables, $previous);
    }

    public function get_response() {
        // Lets log the Exception, Just in case it's important!
        Kohana_Exception::log($this);

        $twig = Twig::factory('errors/http_api');

        $twig->code = $this->getCode();
        $twig->message = $this->getMessage();
        $twig->link = URL::site('');
        $response = Response::factory()
            ->status($this->getCode())
            ->body($twig);

        return $response;
    }
}