<?php defined('SYSPATH') or die('No direct script access.');

class Model_Group extends Model
{
    private $id;

    public static function with($id) {
        $g = new self();
        $g->id = (int) $id;
        return $g;
    }

    /** @return Model_Discipline[] */
    public function getDisciplines($lazy = true, $semesterID = null) {
        $semesterID = $semesterID ?: User::instance()->SemesterID;
        $sql = 'CALL `GetDisciplinesForGroup`(:id, :semesterID)';
        $query = DB::query(Database::SELECT, $sql)
            ->param(':id', $this->id)
            ->param(':semesterID', $semesterID)
            ->execute();

        $list = [];
        foreach ($query as $data)
            $list[] = new Model_Discipline($data, true, $lazy);

        return $list;
    }
}
