<?php defined('SYSPATH') or die('No direct script access.');

class Model_Teachers extends Model
{
    public static function getJobPositions() {
        $sql = 'CALL `GetJobPositions`()';
        return DB::query(Database::SELECT, $sql)->execute()->as_array();
    }

    public static function ofFaculty($facultyID) {
        $sql = 'CALL `GetTeachers`(:faculty, :department)';
        return DB::query(Database::SELECT, $sql)
            ->param(':faculty', $facultyID)
            ->param(':department', 0)
            ->execute();
    }

    public static function ofDepartment($departmentID) {
        $sql = 'CALL `GetTeachers`(:faculty, :department)';
        return DB::query(Database::SELECT, $sql)
            ->param(':department', $departmentID)
            ->param(':faculty', 0)
            ->execute();
    }

    // todo: does it make search among all teachers?
    public static function search($words, $facultyID, $departmentID, $disciplineID = 0) {
        if (!is_array($words))
            $words = [$words];
        $words += ['', '', ''];

        $sql = 'CALL `SearchTeachers`(:faculty, :department, :word1, :word2, :word3, :discipline)';
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':word1'      => $words[0],
                ':word2'      => $words[1],
                ':word3'      => $words[2],
                ':faculty'    => $facultyID,
                ':department' => $departmentID,
                ':discipline' => $disciplineID,
            ])->execute()->as_array();
    }

    public static function searchTeacherNew($facultyID, $departmentID, $last, $first, $second, $disciplineID) {
        $sql = 'CALL `SearchTeacherNew`(:faculty, :department, :last, :first, :second, :discipline)';
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':faculty'    => $facultyID,
                ':department' => $departmentID,
                ':discipline' => $disciplineID,
                ':last'       => $last,
                ':first'      => $first,
                ':second'     => $second,
            ])->execute();
    }
}
