<?php

class RusLang implements ArrayAccess
{
    /**
     *   echo plural_form(42, array('арбуз', 'арбуза', 'арбузов'));
     */
    public static function getNumEnding($n, $forms) {
        return $n % 10 == 1 && $n % 100 != 11 ?
            $forms[0]
            : ($n % 10 >= 2 && $n % 10 <= 4 && ($n % 100 < 10 || $n % 100 >= 20)
                ? $forms[1]
                : $forms[2]);
    }

    private static $arr = [
        'bachelor'   => 'Бакалавриат',
        'specialist' => 'Специалитет',
        'master'     => 'Магистратура',

        'disciplinary_coursework' => 'Курсовая',
        'scientific_coursework'   => 'Курсовая',

        'exam'           => 'Экзамен',
        'credit'         => 'Зачет',
        'grading_credit' => 'Дифф. зачет',

        'autumn' => 'Осень',
        'spring' => 'Весна',
        
        'news'    => 'новости',
        'updates' => 'обновления',
    ];

    /**
     * Translate tool.
     * @param $string string
     * @return string
     * todo: i18n extension 4 twig
     */
    public static function tr($string) {
        return isset(self::$arr[$string]) ? self::$arr[$string] : $string;
    }


    public function offsetGet($offset) { return self::tr($offset); }

    public function offsetExists($offset) { return true; }

    public function offsetSet($offset, $value) { }

    public function offsetUnset($offset) { }
}
